<template>
  <div class="fr-col-lg-8">
    <h2 class="fr-text-title--blue-france fr-mb-2w anct-printable-content">
      {{ subTitle }}
    </h2>
    <FrTitle larger class="anct-printable-content">
      {{ offer.job_title }}
    </FrTitle>

    <FrDownloadPage />

    <div id="offer" class="anct-printable-content">
      <section v-if="offer.us" class="fr-mb-3w">
        <h3>Qui sommes-nous ?</h3>
        <div class="anct-html-content" v-html="markdownToHTML(offer.us)" />
      </section>

      <section v-if="offer.missions" class="fr-mb-3w">
        <h3>Vos missions</h3>
        <div
          class="anct-html-content"
          v-html="markdownToHTML(offer.missions)"
        />
      </section>

      <section v-if="offer.our_vision" class="fr-mb-3w">
        <h3>Pourquoi nous rejoindre</h3>
        <div
          class="anct-html-content"
          v-html="markdownToHTML(offer.our_vision)"
        />
      </section>

      <section v-if="offer.skills" class="fr-mb-3w">
        <h3>Compétences appréciées</h3>
        <div class="anct-html-content" v-html="markdownToHTML(offer.skills)" />
      </section>

      <section v-if="offer.working_conditions" class="fr-mb-3w">
        <h3>Modalités de travail</h3>
        <div
          class="anct-html-content"
          v-html="markdownToHTML(offer.working_conditions)"
        />
      </section>

      <section class="fr-mb-3w">
        <h3>Candidater :</h3>
        <p v-if="applyWithForm">
          Envoyez nous votre CV via le formulaire ci-dessous.
        </p>
        <p v-else>Contactez-nous via email : {{ offer.apply }}</p>
        <p>
          Merci de préciser vos références (GitHub, GitLab ou autres sources
          disponibles).
        </p>
        <p>
          Si vous avez des questions, n’hésitez pas à les poser lors de votre
          entretien.
        </p>
      </section>
    </div>

    <iframe
      v-if="applyWithForm"
      class="airtable-embed airtable-dynamic-height"
      :src="offer.apply"
      width="100%"
      height="1072"
      style="background: transparent; border: 1px solid #ccc"
    />
  </div>
</template>

<script>
import { marked } from 'marked';
import FrTitle from '~/components/ui/Title';
import FrDownloadPage from '~/components/elements/DownloadPage';

export default {
  name: 'RecruitmentItemPage',

  components: { FrTitle, FrDownloadPage },

  async asyncData({ $axios, params, redirect }) {
    const { data } = await $axios.$get('/items/offres_emploi', {
      params: {
        fields:
          'job_title,organization,us,missions,our_vision,skills,working_conditions,apply',
        filter: { slug: { _eq: params.slug }, status: { _eq: 'published' } },
      },
    });

    const [offer] = data;

    if (!offer) {
      return redirect({ name: 'recrutement' });
    }

    return {
      offer,
    };
  },

  data() {
    return {
      offer: {},
    };
  },

  computed: {
    subTitle() {
      return `L'équipe ${this.offer.organization || ''} recrute :`;
    },
    applyWithForm() {
      return this.offer.apply.includes('airtable');
    },
  },

  methods: {
    markdownToHTML(markdown) {
      return marked.parse(markdown);
    },
    print() {
      window.print();
    },
  },
};
</script>

<style scoped>
/deep/ .anct-html-content blockquote {
  margin-left: 0;
  border-left: 4px solid var(--blue-france-main-525);
  padding-left: 16px;
}

/deep/ .anct-html-content blockquote p {
  margin-bottom: 0;
}

/deep/ .anct-html-content blockquote p strong {
  font-weight: normal;
}

/deep/ .anct-html-content ul,
/deep/ .anct-html-content ol {
  margin-left: 24px;
  margin-bottom: 16px;
}

/deep/ .anct-html-content ul p {
  margin-bottom: 8px;
}

/deep/ .anct-html-content h2 {
  margin-top: 48px;
}
</style>
